searchNodes=[{"doc":"Membrane element that cuts raw video. The element expects each frame to be received in a separate buffer, so the parser ( Membrane.Element.RawVideo.Parser ) may be required in a pipeline before the encoder (e.g. when input is read from Membrane.File.Source ). To use this element, specify the desired intervals in the intervals options - VideoCutter will &quot;filter&quot; out all frames with timestamps outside of them. Element options Passed via struct Membrane.VideoCutter.t/0 intervals [ { Membrane.Time . t ( ) , Membrane.Time . t ( ) | :infinity } ] Default value: [{0, :infinity}] List of intervals of timestamps. The buffer is forwarded when its timestamp belongs to any of the given intervals. The start of the interval is inclusive and the end is exclusive. For example, to cut part starting from 190 ms up to 1530 ms out of the video, the intervals should be set to [{0, Membrane.Time.miliseconds(190)}, {Membrane.Time.miliseconds(1530), :infinity}] . offset Membrane.Time . t ( ) Default value: 0 Offset applied to all cut frames' presentation timestamp (PTS) values. It allows to logically shift the video to express its real starting point. For example, if there are two streams and the second one begins two seconds after the first one, video cutter that processes the second stream should apply a 2sec offset. Offset is applied after cutting phase. Pads :input Availability :always Caps Membrane.RawVideo , restrictions: &nbsp;&nbsp; aligned: true Demand mode :auto Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps Membrane.RawVideo , restrictions: &nbsp;&nbsp; aligned: true Demand mode :auto Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.VideoCutter.html","title":"Membrane.VideoCutter","type":"module"},{"doc":"Returns pads descriptions for Membrane.VideoCutter","ref":"Membrane.VideoCutter.html#membrane_pads/0","title":"Membrane.VideoCutter.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.VideoCutter.html#options/0","title":"Membrane.VideoCutter.options/0","type":"function"},{"doc":"Struct containing options for Membrane.VideoCutter","ref":"Membrane.VideoCutter.html#t:t/0","title":"Membrane.VideoCutter.t/0","type":"type"},{"doc":"Membrane element that merges multiple raw videos into one. The element expects each frame to be received in a separate buffer, so the parser ( Membrane.Element.RawVideo.Parser ) may be required in a pipeline before the merger (e.g. when input is read from Membrane.File.Source ). The element expects to receive frames in order from each input. Currently, VideoMerger may not be suitable for live merging streams: the element awaits for at least one frame from each of the inputs, and forwards the one with the lowest presentation timestamp. Pads :input Availability :on_request Caps Membrane.RawVideo , restrictions: &nbsp;&nbsp; aligned: true Demand mode :manual Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps Membrane.RawVideo , restrictions: &nbsp;&nbsp; aligned: true Demand mode :manual Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.VideoMerger.html","title":"Membrane.VideoMerger","type":"module"},{"doc":"Returns pads descriptions for Membrane.VideoMerger","ref":"Membrane.VideoMerger.html#membrane_pads/0","title":"Membrane.VideoMerger.membrane_pads/0","type":"function"},{"doc":"Membrane Bin that cuts and merges multiple raw videos into one. The bin expects each frame to be received in a separate buffer, so the parser ( Membrane.Element.RawVideo.Parser ) may be required in a pipeline before the merger bin (e.g. when input is read from Membrane.File.Source ). The element expects to receive frames in order from each input. The bin consists of single Membrane.VideoMerger and mutliple Membrane.VideoCutter . Number of elements is constant: cutters are created at initialization, one for each stream. Pads :input Availability :on_request Caps Membrane.RawVideo , restrictions: &nbsp;&nbsp; aligned: true Demand unit :buffers Direction :input Mode :pull Name :input Options: stream Stream . t ( ) Required A stream to cut and merge :output Availability :always Caps Membrane.RawVideo , restrictions: &nbsp;&nbsp; aligned: true Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.VideoCutAndMerge.html","title":"Membrane.VideoCutAndMerge","type":"module"},{"doc":"Returns pads descriptions for Membrane.VideoCutAndMerge","ref":"Membrane.VideoCutAndMerge.html#membrane_pads/0","title":"Membrane.VideoCutAndMerge.membrane_pads/0","type":"function"},{"doc":"Options for pad :input","ref":"Membrane.VideoCutAndMerge.html#t:input_pad_opts_t/0","title":"Membrane.VideoCutAndMerge.input_pad_opts_t/0","type":"type"},{"doc":"Structure describing video stream to merge by Membrane.VideoCutAndMerge Fields :intervals - List of intervals of timestamps that are supposed to be cut and kept from the stream. :offset - Offset applied to all franes' presentation timestamp values.","ref":"Membrane.VideoCutAndMerge.Stream.html","title":"Membrane.VideoCutAndMerge.Stream","type":"module"},{"doc":"","ref":"Membrane.VideoCutAndMerge.Stream.html#t:t/0","title":"Membrane.VideoCutAndMerge.Stream.t/0","type":"type"},{"doc":"Plugin containing elements for cutting and merging raw video. By using this plugin you can simply merge multiple video tracks ( VideoMerger ) cut out specific intervals of video track ( VideoCutter ) combine chosen parts raw video tracks into one ( VideoCutAndMerge ), for instance by taking the first half of one track and combining it with the second half of another For most cases, the VideoCutAndMerge bin should be your first choice. Implementations of the VideoCutter and the VideoMerger are using presentation timestamps, so every Buffer should have the pts field set. It is part of Membrane Multimedia Framework .","ref":"readme.html","title":"Membrane VideoMerger Plugin","type":"extras"},{"doc":"The package can be installed by adding membrane_video_merger_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_video_merger_plugin , &quot;~&gt; 0.6.0&quot; } ] end","ref":"readme.html#installation","title":"Membrane VideoMerger Plugin - Installation","type":"extras"},{"doc":"Both pipelines will result in creating /tmp/output.raw file with the first 5 seconds of the input_1 track and everything but the first 5 seconds of the input_2 track. /tmp/input_1.h264 and /tmp/input_2.h264 should be an H264 video files. CutAndMerge bin defmodule VideoCutAndMerge.Pipeline do use Membrane.Pipeline alias Membrane.VideoCutAndMerge alias Membrane.H264.FFmpeg . { Parser , Decoder } alias Membrane.File . { Sink , Source } @impl true def handle_init ( _ ) do children = [ file_src_1 : % Source { chunk_size : 40_960 , location : &quot;/tmp/input_1.h264&quot; } , parser_1 : % Parser { framerate : { 30 , 1 } } , decoder_1 : Decoder , file_src_2 : % Source { chunk_size : 40_960 , location : &quot;/tmp/input_2.h264&quot; } , parser_2 : % Parser { framerate : { 30 , 1 } } , decoder_2 : Decoder , cut_and_merge : VideoCutAndMerge , sink : % Sink { location : &quot;/tmp/output.raw&quot; } ] stream_1 = % VideoCutAndMerge.Stream { intervals : [ { 0 , Membrane.Time . seconds ( 5 ) } ] } stream_2 = % VideoCutAndMerge.Stream { intervals : [ { Membrane.Time . seconds ( 5 ) , :infinity } ] } links = [ link ( :file_src_1 ) |&gt; to ( :parser_1 ) |&gt; to ( :decoder_1 ) |&gt; via_in ( Pad . ref ( :input , 1 ) , options : [ stream : stream_1 ] ) |&gt; to ( :cut_and_merge ) , link ( :file_src_2 ) |&gt; to ( :parser_2 ) |&gt; to ( :decoder_2 ) |&gt; via_in ( Pad . ref ( :input , 2 ) , options : [ stream : stream_2 ] ) |&gt; to ( :cut_and_merge ) , link ( :cut_and_merge ) |&gt; to ( :sink ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , %{ } } end end VideoCutter and VideoMerger defmodule VideoMerger.Pipeline do use Membrane.Pipeline alias Membrane.H264.FFmpeg . { Parser , Decoder } alias Membrane.File . { Sink , Source } alias Membrane . { VideoCutter , VideoMerger } @impl true def handle_init ( _ ) do children = [ file_src_1 : % Source { chunk_size : 40_960 , location : &quot;/tmp/input_1.h264&quot; } , parser_1 : % Parser { framerate : { 30 , 1 } } , decoder_1 : Decoder , cutter_1 : % VideoCutter { intervals : [ { 0 , Membrane.Time . seconds ( 5 ) } ] } , file_src_2 : % Source { chunk_size : 40_960 , location : &quot;/tmp/input_2.h264&quot; } , parser_2 : % Parser { framerate : { 30 , 1 } } , decoder_2 : Decoder , cutter_2 : % VideoCutter { intervals : [ { Membrane.Time . seconds ( 5 ) , :infinity } ] } , merger : VideoMerger , sink : % Sink { location : &quot;/tmp/output.raw&quot; } ] links = [ link ( :file_src_1 ) |&gt; to ( :parser_1 ) |&gt; to ( :decoder_1 ) |&gt; to ( :cutter_1 ) |&gt; via_in ( Pad . ref ( :input , 1 ) ) |&gt; to ( :merger ) , link ( :file_src_2 ) |&gt; to ( :parser_2 ) |&gt; to ( :decoder_2 ) |&gt; to ( :cutter_2 ) |&gt; via_in ( Pad . ref ( :input , 2 ) ) |&gt; to ( :merger ) , link ( :merger ) |&gt; to ( :sink ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , %{ } } end end","ref":"readme.html#sample-usage","title":"Membrane VideoMerger Plugin - Sample Usage","type":"extras"},{"doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane VideoMerger Plugin - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]